#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);
    int n,q,x,l,r;
    cin>>n>>q;
    int niz[n+1];
    for(int i=1;i<=n;++i)
    {
        cin>>niz[i];
    }
    for(int i=0;i<q;++i)
    {
        cin>>l>>r;
        x=niz[l];
        for(int i=l+1;i<=r;++i){x=x&niz[i];if(x==0)break;}
        cout<<x<<endl;
    }



    return 0;
}